# -*- coding: utf-8 -*-
from openerp import models, fields, tools, api


class constructionUom(models.Model):
    _name = 'construction.uom'

    name = fields.Char('name', required=True)
    active = fields.Boolean('Active', default=True)
    ref = fields.Char('Ref')
    decimal_places = fields.Integer(string='Decimal Place', default=0, required=True)
    comment = fields.Text('Comment', help='Información Adicional')

    @api.model
    def create_default_uon(self):

        defaultUom = [
            {'name':'M2','ref': 'Metros Cuadrados', 'decimal_places':2},
            {'name':'UN', 'ref': 'Unidad', 'decimal_places':0},
            {'name':'M3', 'ref': 'Metros  Cúbicos', 'decimal_places':3},
            {'name':'ML', 'ref': 'Metros Lineal', 'decimal_places':2},
            {'name':'BC', 'ref': '', 'decimal_places': 0}
        ]
        for uom in defaultUom:
            oumExist = self.env['construction.uom'].search([('name', '=', uom['name'])])

            if (not oumExist):
                oumExist.create({
                    'name': uom['name'],
                    'ref': uom['ref'],
                    'decimal_places': uom['decimal_places'],
                })
