# -*- coding: utf-8 -*-
from openerp import models, fields, tools, api

class dataConstructionUom(models.Model):
    _inherit = 'construction.uom'

    @api.model
    def create_default_uon(self):

        defaultUom = [
            {'name':'M2','ref': 'Metros Cuadrados', 'decimal_places':2},
            {'name':'UN', 'ref': 'Unidad', 'decimal_places':0},
            {'name':'M3', 'ref': 'Metros  Cúbicos', 'decimal_places':3},
            {'name':'ML', 'ref': 'Metros Lineal', 'decimal_places':2},
            {'name':'BC', 'ref': '', 'decimal_places': 0}
        ]
        for uom in defaultUom:
            oumExist = self.env['construction.uom'].search([('name', '=', uom['name'])])

            if (not oumExist):
                oumExist.create({
                    'name': uom['name'],
                    'ref': uom['ref'],
                    'decimal_places': uom['decimal_places'],
                })

    def get_oum_name(self, name):
        return self.env['construction.uom'].search([('name', '=', name)]).id or None

class dataConstructionTask(models.Model):
    _inherit = 'construction.task'

    @api.model
    def create_default_task(self):
        oumTask = self.env['construction.uom']
        tasks = [
            {
                'code': '1',
                'name': 'PROYECTOS (APAR-LEY 1012)',
                'line_ids': [
                    {'code': '1.1', 'name': 'Estudios preliminares y programación', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '1.2', 'name': 'Anteproyecto',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '1.3', 'name': 'Diseño arquitectonico detallado', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '1.4', 'name': 'Diseño estructural y especificaciones', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '1.5', 'name': 'Memoria general y especificaciones', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '1.6', 'name': 'Direccion  de obra', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '1.7', 'name': 'Otros', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '1.8', 'name': 'Serviocio de mano de obra', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '2',
                'name': 'TRABAJOS PRELIMINARES',
                'line_ids': [
                    {'code': '2.1', 'name': 'Obrajero',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '2.2', 'name': 'Galpon de obra',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '2.3', 'name': 'Conexión de energia electrica (ANDE)',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '2.4', 'name': 'Conexión de agua corriente',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '2.5', 'name': 'Conexión a red cloacal y sanitaria',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '2.6', 'name': 'Replanteo de obra',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '2.7', 'name': 'Otros',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '2.8', 'name': 'Servicio de mano de obra',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '3',
                'name': 'MOVIMIENTO DE SUELO',
                'line_ids':[
                    {'code': '3.1', 'name': ' Terraplenado', 'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '3.2', 'name': 'Excabaciones a maquinas', 'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '3.3', 'name': 'Desmonte manual', 'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '3.4', 'name': 'Rellenos', 'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '3.5', 'name': 'Limpieza y destronco de arboles',  'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '3.6', 'name': 'Otros', 'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '3.7', 'name': 'Servicio de mano de obra', 'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''}
                ]
            },
            {

                'code': '4',
                'name': 'FUNDACION',
                'line_ids': [
                    {'code': '4.1', 'name': 'Excabacion para zapatas',  'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '4.2', 'name': 'Zapata',  'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '4.3', 'name': 'Colmmunas o pilares',  'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '4.4', 'name': 'Bigas superior e inferior',  'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '4.5', 'name': 'Losa de hormigon armado (Hº Aº)',  'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '4.6', 'name': 'Escalera',  'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '4.7', 'name': 'Submuracion',  'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '4.8', 'name': 'Otros',  'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''},
                    {'code': '4.9', 'name': 'Servico de mano de obra',  'construction_uom': oumTask.get_oum_name('M3'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '5',
                'name': 'IMPERMEABILIZACON',
                'line_ids': [
                    {'code': '5.1', 'name': 'Aislacion horizontal 0,15m con hidrofugo y asfalto', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '5.2', 'name': 'Aislacion de losa para baño', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '5.3', 'name': 'Otros',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '5.4', 'name': 'Servicio de mano de obra', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '','comment': ''}
                ]
            },
            {
                'code': '6',
                'name': 'ALBAÑILERIA',
                'line_ids': [
                    {'code': '6.1', 'name': 'Nivelacion 0,30m',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '6.2', 'name': 'Mamposteria de elevacion 0,15m (ladrillo hueco)', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '6.3', 'name': 'Mamposteria de elevacion 0,15m (ladrillo comun)',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '6.4', 'name': 'Mamposteria de elevacion 0,20m (ladrillo comun)',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '6.5', 'name': 'Mamposteria de elevacion 0,20m (ladrillo hueco)',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '6.6', 'name': 'Dintel sobre abertura  / envarillado de mamposteria',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '6.7', 'name': 'Otros',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '6.8', 'name': 'Servicio de mano obra',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''}
                ],
            },
            {
                'code': '7',
                'name': 'COBERTURA  CUBIERTAS',
                'line_ids': [
                    {'code': '7.1', 'name': 'Estructura de madera (tirantes y vigas)',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '7.2', 'name': 'Cielo rasos (machimbre, pvc, otros)',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '7.3', 'name': 'Estructura de metal con teja',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '7.4', 'name': 'EstruC. de metal con chapa tipo teja, trapez, ondul.',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '7.5', 'name': 'Otros',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '7.6', 'name': 'Servcio de mano de obra',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '8',
                'name': 'CIELORRASOS',
                'line_ids': [
                    {'code': '8.1', 'name': 'Yeso acartonado',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '8.2', 'name': 'Yesito placa 60x60',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '8.3', 'name': 'Yeso de pvc',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '8.4', 'name': 'Machimbre de madera',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '8.5', 'name': 'Otros',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '8.6', 'name': 'Servicio de mano de obra',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '9',
                'name': 'REVOQUES',
                'line_ids': [
                    {'code': '9.1', 'name': 'Revoque una capa sin hidrofugo en interiores',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '9.2', 'name': 'Revoque una capa con hidrofugo en exteriores',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '9.3', 'name': 'Azotada impermeable 0,5m',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '9.4', 'name': 'Revoque de cielo raso a una capa',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '9.5', 'name': 'Otros',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '9.6', 'name': 'Servicio de mano de obra',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '10',
                'name': 'CONTRAPISO Y CARPETA ALISADA',
                'line_ids':[
                    {'code': '10.1', 'name': 'Contrapiso de 7cm',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '10.2', 'name': 'Contrapiso de hormigon de cascotes',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '10.3', 'name': 'Contrapiso en losa sanitaria 20cm',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '10.4', 'name': 'Otros',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '10.5', 'name': 'Servicio de mano de obra',  'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                ]
            },
            {
                'code': '11',
                'name': 'REVESTIMIENTO',
                'line_ids': [
                    {'code': '11.1', 'name': 'Azulejos', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': '* Ceramico \n* Porcelanato \n* Otros'},
                    {'code': '11.2', 'name': 'Pisos', 'construction_uom': oumTask.get_oum_name('M2'),  'ref': '', 'comment': '* Ceramico \n* Porcelanato \n* Otros'},
                    {'code': '11.3', 'name': 'Decorados', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': '* Pastilla de vidrio \n* Pastilla mixto \n* Otros'},
                    {'code': '11.4', 'name': 'Granitos y marmol', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '11.5', 'name': 'Otros', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '11.6', 'name': 'Servicio de mano de obra', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '12',
                'name': 'ZOCALOS',
                'line_ids':	[
                    {'code': '12.1', 'name': 'Ceramico',  'construction_uom': oumTask.get_oum_name('ML'), 'ref': '', 'comment': ''},
                    {'code': '12.2', 'name': 'Madera',  'construction_uom': oumTask.get_oum_name('ML'), 'ref': '', 'comment': ''},
                    {'code': '12.3', 'name': 'PVC',  'construction_uom': oumTask.get_oum_name('ML'), 'ref': '', 'comment': ''},
                    {'code': '12.4', 'name': 'Otros',  'construction_uom': oumTask.get_oum_name('ML'), 'ref': '', 'comment': ''},
                    {'code': '12.5', 'name': 'Servicio de mano de obra',  'construction_uom': oumTask.get_oum_name('ML'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '13',
                'name': 'INSTALACIONES HIDRAULICAS',
                'line_ids': [
                    {'code': '13.1',  'name': 'Baño social',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '13.2',  'name': 'Baño familiar',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '13.3',  'name': 'Baño suit sin bañera planta alta',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '13.4',  'name': 'Baño suit con bañera planta alta',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '13.5',  'name': 'Cocina en planta baja',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '13.6',  'name': 'Cocina en planta alta',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '13.7',  'name': 'Cocina lavadero',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '13.8',  'name': 'Desague pluvial',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '13.9',  'name': 'Desague cloacal',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '13.10', 'name': 'Otros',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '13.11', 'name': 'Servicio de mano de obra',  'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '14',
                'name': 'INSTALCIONES ELECTRICAS',
                'line_ids': [
                    {'code': '14.1', 'name': 'Bocas electricas', 'construction_uom': oumTask.get_oum_name('BC'), 'ref': '', 'comment': ''},
                    {'code': '14.2', 'name': 'Colocacion de artefactos', 'construction_uom': oumTask.get_oum_name('BC'), 'ref': '', 'comment': ''},
                    {'code': '14.3', 'name': 'Otros',  'construction_uom': oumTask.get_oum_name('BC'), 'ref': '', 'comment': ''},
                    {'code': '14.4', 'name': 'Servicio de mano de obra', 'construction_uom': oumTask.get_oum_name('BC'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '15',
                'name': "PUERTAS",
                'line_ids': [
                    {'code': "15.1", 'name': 'Puertas tablero (exterior)', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': "15.2", 'name': 'Puertas placas (interior)', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': "15.3", 'name': 'Puertas de aluminio (baños)', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': "15.4", 'name': 'Otros', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': "15.5", 'name': 'Servicio de mano de obra', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '16',
                'name': 'VENTANAS',
                'line_ids': [
                    {'code': '16.1', 'name': 'De madera', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '16.2', 'name': 'De aluminio (carpinteria)', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '16.3', 'name': 'De vidrio templado', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '16.4', 'name': 'Otros', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '16.5', 'name': 'Servicio de mano de obra', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '17',
                'name': 'PINTURA',
                'line_ids': [
                    {'code': '17.1', 'name': 'De paredes', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '17.2', 'name': 'De techo', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '17.3', 'name': 'De cielo raso', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '17.4', 'name': 'De abertura', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '17.5', 'name': 'Otros', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''},
                    {'code': '17.6', 'name': 'Servicio de mano de obra', 'construction_uom': oumTask.get_oum_name('M2'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '18',
                'name': 'COLOCACION DE ARTEFACTOS SANITARIOS',
                'line_ids': [
                    {'code': '18.1', 'name': 'Lavatorio', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '18.2', 'name': 'Canilla', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '18.3', 'name': 'Bidet', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '18.4', 'name': 'Ducha higienica', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '18.5', 'name': 'Inodoro', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '18.6', 'name': 'Ducha electrica', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '18.7', 'name': 'Pileta de lavar', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '18.8', 'name': 'Box de baño', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '18.9', 'name': 'Otros', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '18.10', 'name': 'Servicio de mano de obra', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '19',
                'name': 'ESCALERAS - BALCONES',
                'line_ids': [
                    {'code': '19.1', 'name': 'Barandas de vidrios', 'construction_uom': oumTask.get_oum_name('ML'), 'ref': '', 'comment': ''},
                    {'code': '19.2', 'name': 'Barandas de metal pintado', 'construction_uom': oumTask.get_oum_name('ML'), 'ref': '', 'comment': ''},
                    {'code': '19.3', 'name': 'Barandas de inox', 'construction_uom': oumTask.get_oum_name('ML'), 'ref': '', 'comment': ''},
                    {'code': '19.4', 'name': 'Pasa mano', 'construction_uom': oumTask.get_oum_name('ML'), 'ref': '', 'comment': ''},
                    {'code': '19.5', 'name': 'Otros', 'construction_uom': oumTask.get_oum_name('ML'), 'ref': '', 'comment': ''},
                    {'code': '19.6', 'name': 'Servcio de mano de obra', 'construction_uom': oumTask.get_oum_name('ML'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '20',
                'name': 'JARDINERIA Y PAISAJISMO',
                'line_ids': [
                    {'code': '20.1', 'name': 'Estilo 1', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '20.2', 'name': 'Estilo 2', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '20.3', 'name': 'Estilo 3', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '20.4', 'name': 'Estilo 4', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '20.5', 'name': 'Otros', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '20.6', 'name': 'Servcio de mano de obra', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '21',
                'name': 'CHURRASQUERA',
                'line_ids': [
                    {'code': '21.1', 'name': 'Accesorios completo (inox)', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '21.2', 'name': 'Otros accesorios', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '21.3', 'name': 'Enlozado', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '21.4', 'name': 'Otros', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '21.5', 'name': 'Servicio de mano de obra', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''}
                ]
            },
            {
                'code': '22',
                'name': 'PISCINAS',
                'line_ids': [
                    {'code': '22.1', 'name': 'Otros', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''},
                    {'code': '22.2', 'name': 'Mano de obra', 'construction_uom': oumTask.get_oum_name('UN'), 'ref': '', 'comment': ''}
                ]
            }
        ]

        for task in tasks:
            taskExist = self.env['construction.task'].search([('name', '=', task['name'])])

            if (not taskExist):
                lineids = []
                for line in task['line_ids']:
                    lineids.append([0, False, {
                        'code': line['code'],
                        'name': line['name'],
                        'construction_uom': line['construction_uom']
                    }])

                taskExist.create({
                    'code': task['code'],
                    'name': task['name'],
                    'line_ids': lineids
                })
