(function() {

    openerp.widgetInstanceEiruAddInvoiceTaskExpenses = null;
    openerp.parentInstanceEiruAddInvoiceTaskExpenses = null;
    var Qweb = openerp.web.qweb;
    var instance = openerp;
    var instanceWeb = openerp.web;

    openerp.EiruAddInvoiceTaskExpenses = instance.Widget.extend({
        template: 'eiruAddInvoiceTask.Expenses',
        id: undefined,

        taskOrder: [],
        currencyFormat: [],

        init: function(parent) {
            this._super(parent);
            this.buttons = parent.$buttons;
        },

        start: function() {
            var self = this;

            this.$el.click(function(){
                self.fectchInitial()
            });
            self.buttons.click(function(e) {
                /* E (Editar) */
                if (e.target.accessKey === 'E')
                    self.$el.css('display','none');
                /* S (Guarrdar) */
                if (e.target.accessKey === 'S')
                    self.$el.css('display','flex');
                /* D (Cancelar) */
                if (e.target.accessKey === 'D')
                    self.$el.css('display','flex');
                /* CREAR */
                if (e.target.accessKey === 'C')
                    self.$el.css('display','none');
            });
        },

        updateId: function(id) {
            var self = this;
            self.id = id;

            self.$el.css('display','flex');
            if (!id)
                self.$el.css('display','none');
        },

        /* Remover */
        removeModal: function() {
            $('.expired-account-modal').remove();
            $('.modal-backdrop').remove();
        },

        /* Reloada */
        reloadPage: function() {
            openerp.parentInstanceEiruAddInvoiceTaskExpenses.reload();
        },

        /* Metodo Inicial */
        fectchInitial: function() {
            var self = this;
            self.fetchTaskOrderExpenses(self.id).then(function(taskOrder) {
                return taskOrder;
            }).then(function(taskOrder) {
                console.log(taskOrder);
                self.taskOrder = taskOrder;
                return self.fetchCurrencyInvoice(self.id);
            }).then(function(currencyFormat) {
                self.currencyFormat = currencyFormat;
                console.log(currencyFormat);
                return self.showTaskExpenses()
            });
        },

        /* GET task */
        fetchTaskOrderExpenses: function(id) {
            var task = new openerp.web.Model('account.invoice')
            return task.call('getAccountInvoiceOrder',[id],{
                context: new openerp.web.CompoundContext()
            });
        },

        /* GET CURRENCY ORDER */
        fetchCurrencyInvoice: function(id) {
            var budget = new openerp.web.Model('account.invoice')
            return budget.call('getCurrencyInvoceExpenses',[id],{
                context: new openerp.web.CompoundContext()
            });
        },

        /* Modal */
        showTaskExpenses: function() {
            var self = this;
            var defer = $.Deferred();
            var state = true;
            var modal = Qweb.render('eiruInvoiceTaskExpenses.Modal',{'tasks': self.taskOrder});

            $('.openerp_webclient_container').after(modal);
            $('.expired-account-modal').modal();

            var tableRow = $('.expired-account-modal').find('.table-tbody').find('tr');
            var buttonAccept = $('.expired-account-modal').find('.button-accept');

            /*----------
            |    INIT   |
            -----------*/
            _.each(tableRow, function(tr) {
                var amountTotal = ($($(tr).children()[3]).find('.invoice-task-total'));
                var amountExpenses = ($($(tr).children()[4]).find('.invoice-task-expenses'));
                var amountResidual = ($($(tr).children()[5]).find('.invoice-task-residual'));

                var total = instanceWeb.unFormatCurrency(amountTotal.val());
                var expense = instanceWeb.unFormatCurrency(amountExpenses.val());
                var residual = instanceWeb.unFormatCurrency(amountResidual.val());

                amountTotal.val(instanceWeb.formatCurrency(total, self.currencyFormat))
                amountExpenses.val(instanceWeb.formatCurrency(expense, self.currencyFormat))
                amountResidual.val(instanceWeb.formatCurrency(residual, self.currencyFormat))
            });

            /*-------------
            |    CLICK    |
            -------------*/
            tableRow.click(function(e) {
                if (($(e.target).index() !== 0) ||(($(e.target).index() === 0) && ($(e.target)[0].className !== 'select-task-expenses')))
                    return false;

                $(e.target).closest('tr').removeClass('selected-task');
                if (e.target.checked === true) {
                    $(e.target).closest('tr').addClass('selected-task');
                }
            });

            /*---------------
            |   GUARDAR     |
            ---------------*/
            buttonAccept.click(function(e){
                var orderTask = [];
                _.each(tableRow, function(tr) {
                    if (($($(tr).children()[0]).find('.select-task-expenses'))[0].checked) {
                        orderTask.push({
                            'code': ($(tr).children()[1].textContent).trim(),
                            'moveLineId': parseInt(($(tr).children()[6].textContent).trim()),
                        })
                    }
                });

                if (!orderTask.length) {
                    instanceWeb.notification.do_warn("Atencion", "Debes seleccionar al menos una tarea.");
                    return
                }

                self.addTaskContractorExpenses(self.id, orderTask).then(function(taskAdd) {
                    return taskAdd;
                }).then(function(taskAdd) {
                    state = taskAdd.state;
                    if (!taskAdd.state)
                        instanceWeb.notification.do_warn("Atencion", taskAdd.message);
                    self.reloadPage();
                    self.removeModal(e);
                });

                defer.resolve(state);
            });

            /* Click Cerrar */
            $('.expired-account-modal').on('hidden.bs.modal', function (e) {
                defer.resolve(false);
                self.removeModal(e);
            });

            return defer;
        },

        /*-------------------
        | ADD TASK IN LINE  |
        -------------------*/
        addTaskContractorExpenses: function(idInvoice,tasks) {
            var contractor = new instance.web.Model('account.invoice');
            return contractor.call('addTaskExpensesMove',[idInvoice, tasks], {
                context: new instance.web.CompoundContext()
            });
        },
    });

    if (instance.web && instance.web.FormView) {
        instance.web.FormView.include({
            load_record: function(record) {
                this._super.apply(this, arguments);

                if (this.model !== 'account.invoice')
                    return;

                openerp.parentInstanceEiruAddInvoiceTaskExpenses = this;

                if (openerp.widgetInstanceEiruAddInvoiceTaskExpenses) {
                    openerp.widgetInstanceEiruAddInvoiceTaskExpenses.updateId(record.id);
                    if (this.$el.find('.button-add-task-invoice-expenses').length !== 0){
                        return
                    }
                }

                if (this.$el.find('.button-add-task-invoice-expenses').length !== 0 )
                    return;

                openerp.widgetInstanceEiruAddInvoiceTaskExpenses = new openerp.EiruAddInvoiceTaskExpenses(this);
                var elemento = this.$el.find('.oe_form').find('.eiru-task-expenses-add');

                openerp.widgetInstanceEiruAddInvoiceTaskExpenses.appendTo(elemento);
                openerp.widgetInstanceEiruAddInvoiceTaskExpenses.updateId(record.id);

            },

        });
    }
})();
